// RegWriteDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RegWrite.h"
#include "RegWriteDlg.h"

#include "..\..\include\AdamTcpCE.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

wchar_t	szwIPAddress[20];

int MbsToWcs (char* mbs, wchar_t* wcs);
int WcsToMbs (wchar_t* wcs, char* mbs);

#define  DeviceID       0x01  // 0x01 indicate the 5000/TCP
#define  DEFAULT_PORT   502  // Port for Modbus/TCP
//-------- default timeout ------
int      iConnectionTimeout=5000;
int      iSendTimeout=5000;
int      iReceiveTimeout=5000;

int MbsToWcs (char* mbs, wchar_t* wcs)
{
	wchar_t g_wcConverter[256];
	size_t len = strlen (mbs);
	memset (g_wcConverter, 0, sizeof(g_wcConverter));
	if (len > 127) return NULL;
	mbstowcs(g_wcConverter, mbs, len);
	wcscpy(wcs, g_wcConverter);
	return len;
}

int WcsToMbs (wchar_t* wcs, char* mbs)
{
	char	g_mbConvert[256];
	size_t len = wcslen (wcs);
	if (len >= sizeof(g_mbConvert)) len = sizeof(g_mbConvert) - 1;
	wcstombs(g_mbConvert, wcs, len);
	strcpy(mbs, g_mbConvert);
	return len;
}

/////////////////////////////////////////////////////////////////////////////
// CRegWriteDlg dialog

CRegWriteDlg::CRegWriteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRegWriteDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRegWriteDlg)
	m_strData0 = _T("");
	m_strData1 = _T("");
	m_strData2 = _T("");
	m_strData3 = _T("");
	m_strData4 = _T("");
	m_strData5 = _T("");
	m_strData6 = _T("");
	m_strData7 = _T("");
	m_strDeviceID = _T("");
	m_strDLLVersion = _T("");
	m_strIPAddress = _T("");
	m_strNoOfWrite = _T("");
	m_strStartAddress = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRegWriteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRegWriteDlg)
	DDX_Text(pDX, IDC_EDIT_DATA0, m_strData0);
	DDX_Text(pDX, IDC_EDIT_DATA1, m_strData1);
	DDX_Text(pDX, IDC_EDIT_DATA2, m_strData2);
	DDX_Text(pDX, IDC_EDIT_DATA3, m_strData3);
	DDX_Text(pDX, IDC_EDIT_DATA4, m_strData4);
	DDX_Text(pDX, IDC_EDIT_DATA5, m_strData5);
	DDX_Text(pDX, IDC_EDIT_DATA6, m_strData6);
	DDX_Text(pDX, IDC_EDIT_DATA7, m_strData7);
	DDX_Text(pDX, IDC_EDIT_DEVICEID, m_strDeviceID);
	DDX_Text(pDX, IDC_EDIT_DLLVER, m_strDLLVersion);
	DDX_Text(pDX, IDC_EDIT_IPADDRESS, m_strIPAddress);
	DDX_Text(pDX, IDC_EDIT_NOOFWRITE, m_strNoOfWrite);
	DDX_Text(pDX, IDC_EDIT_STARTADDRESS, m_strStartAddress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRegWriteDlg, CDialog)
	//{{AFX_MSG_MAP(CRegWriteDlg)
	ON_BN_CLICKED(IDC_WRITEREGISTER, OnWriteregister)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRegWriteDlg message handlers

BOOL CRegWriteDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_strIPAddress="172.18.3.180";
	m_strDeviceID="1";
	m_strStartAddress="1";
	m_strNoOfWrite="8";

	SetDlgItemText(IDC_EDIT_IPADDRESS,m_strIPAddress);
	SetDlgItemText(IDC_EDIT_DEVICEID,m_strDeviceID);
	SetDlgItemText(IDC_EDIT_STARTADDRESS,m_strStartAddress);
	SetDlgItemText(IDC_EDIT_NOOFWRITE,m_strNoOfWrite);
	
	int nID=IDC_EDIT_DATA0;
	for(int i=0; i<8; i++)
	{
		SetDlgItemText( nID+i,_T("123") );
    }
	
	// get the DLL version 
	char     szCh[20];
	//wchar_t  szwCh[20];
    int    iVersion;    
 
	iVersion=ADAMTCP_GetDLLVersion();
	_ltoa( iVersion, szCh, 16 );

	size_t len = strlen (szCh);
	wchar_t  wcConverter[20];

	memset (wcConverter, 0, sizeof(wcConverter));

	mbstowcs(wcConverter, szCh, len);
	//wsprintf(szwCh,"%s",szCh);
	SetDlgItemText(IDC_EDIT_DLLVER, wcConverter);

    //--- To initialize DLL to work ---
    int   iRetVal;

    iRetVal=ADAMTCP_Open();
    if( iRetVal!=0 )
    {
        MessageBox(_T("ADAMTCP_Open() Failure !!!"));
    }	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CRegWriteDlg::OnWriteregister() 
{
	// TODO: Add your control notification handler code here
    CString   strText,strTemp;
	char      *stopstring;
	int       i,iRetVal,nID;
    WORD      wDeviceID;
	WORD      wStartAddress;
    WORD      wCount;
    WORD      wData[64];  
	TCHAR	  szwTemp[80];
	TCHAR     szwDump[80];
	char      szTemp[80];
	float     fData;


	// How many registers to write
	GetDlgItemText(IDC_EDIT_NOOFWRITE,szwTemp, 80*sizeof(TCHAR));
	iRetVal = WcsToMbs (szwTemp, szTemp);	szTemp[iRetVal] = 0;
	wCount=atoi(szTemp);
	if( wCount<0 || wCount>8 )
	{
		MessageBox( _T("The # of register must between 1 to 8 !") );
		return;
	}

	// the device ID
	GetDlgItemText(IDC_EDIT_DEVICEID,szwTemp, 80*sizeof(TCHAR));
	iRetVal = WcsToMbs (szwTemp, szTemp);	szTemp[iRetVal] = 0;
	wDeviceID=atoi(szTemp);

	// the start address to read
	//--- Notice: the address start at 1 instead of 40001
	GetDlgItemText(IDC_EDIT_STARTADDRESS,szwTemp, 80*sizeof(TCHAR));
	iRetVal = WcsToMbs (szwTemp, szTemp);	szTemp[iRetVal] = 0;
	wStartAddress=atoi(szTemp);

    // get the 5000/TCP's IP Address
	GetDlgItemText(IDC_EDIT_IPADDRESS,szwIPAddress,20);
    
	//--- try to create a connection to 5000/TCP ---
    iRetVal=ADAMTCP_Connect(szwIPAddress,DEFAULT_PORT,
				  iConnectionTimeout, iSendTimeout, iReceiveTimeout);

    if( iRetVal<0 )
    {
        wsprintf(szwDump,_T("ADAMTCP_Connect() Failure !!!   code=%d"),iRetVal);
        MessageBox(szwDump);
		ADAMTCP_Disconnect();
        return;
    }

    //--- prepare the data for writing to 5000/TCP ---
	nID=IDC_EDIT_DATA0;
	for(i=0; i<8; i++)
	{
		GetDlgItemText(nID+i,szwTemp, 80*sizeof(TCHAR));
		iRetVal = WcsToMbs (szwTemp, szTemp);	szTemp[iRetVal] = 0;
		
		wData[i]=(WORD)strtol(szTemp, &stopstring, 16);
		//fData = atof(szTemp);	
		//wData[i] = (WORD) (fData+10.0f)*65536.0f/20.0f;
		//wData[i]=(WORD)_atof(stopstring);
	}
    
	//--- writng the registers ---
    iRetVal=ADAMTCP_WriteReg(szwIPAddress, wDeviceID, wStartAddress, wCount, wData);
    if( iRetVal )
    {
        wsprintf(szwDump, _T("ADAMTCP_WriteReg() Failure !!!   code=%d"),iRetVal);
        MessageBox(szwDump);
        ADAMTCP_Disconnect();
        return;
    }

    //--- lastly, disconnt connection to 5000/TCP ---
    ADAMTCP_Disconnect();
	
}

void CRegWriteDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
    ADAMTCP_Close();	
	
	// TODO: Add your control notification handler code here
	CDialog::OnOK();	
}
